/**
 * 
 */
package cotsbots.userballfollowing;

import java.util.ArrayList;

import cotsbots.userballfollowing.ScreenData.ScreenLocation;

/**
 * @author stinger
 * 
 */
public class DirectionVector {
	private static final int fDirectionValuesFilled = 4;
	private ScreenLocation mBallDirection;
	private ScreenLocation mOldBallDirection;
	private int mValueIdx = 0;
	private ArrayList<Double> mDirectionVals;
	private double mDirectionThreshold = 0.03;

	public enum Speed {
		FULL, INCREASE, DECREASE, SAME
	}

	Speed mBallSpeed;
//	private double mDistanceThreshold = 0.1;
//	private double mOldDistanceVal = 0;

	public DirectionVector() {
		mBallDirection = ScreenLocation.NONE;
		mOldBallDirection = ScreenLocation.NONE;
		// We multiply by 2 to add both a left and right track value
		mDirectionVals = new ArrayList<Double>(fDirectionValuesFilled);
		mBallSpeed = Speed.SAME;
	}

	public void updateDirection(double direction) {
		if (mValueIdx == 4) {
			mDirectionVals.remove(0);
		} else {
			mValueIdx++;
		}

		mDirectionVals.add(direction);

		if (mValueIdx == fDirectionValuesFilled) {
			if ((mDirectionVals.get(0) > mDirectionVals.get(3)
					+ mDirectionThreshold)) {
				// Ball is heading left
				mBallDirection = ScreenLocation.LEFT;
			} else if ((mDirectionVals.get(0) + mDirectionThreshold < mDirectionVals
							.get(3))) {
				// Ball is heading right
				mBallDirection = ScreenLocation.RIGHT;
			} else {
				if (mBallDirection != ScreenLocation.NONE) {
					mOldBallDirection = mBallDirection;
				}
				mBallDirection = ScreenLocation.NONE;
			}
		}
	}

	public void clearSpeed() {
		mBallSpeed = Speed.FULL;
	}

	public void clearDirection() {
		mBallDirection = ScreenLocation.NONE;
		mOldBallDirection = ScreenLocation.NONE;
		mBallSpeed = Speed.SAME;
		mValueIdx = 0;
		mDirectionVals.clear();
	}

	public Speed getVelocityChange() {
		return mBallSpeed;
	}

	public ScreenLocation getDirection() {
		return mBallDirection;
	}

	public ScreenLocation getLastDirection() {
		return mOldBallDirection;
	}
}
