package cotsbots.userballfollowing;

import java.text.DecimalFormat;

import org.opencv.core.Core;


import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.util.Log;

public class FpsMeter {
	private static final String TAG = "Sample::FpsMeter";
	int step;
	int framesCouner;
	double freq;
	long prevFrameTime;
	String strfps;
	DecimalFormat twoPlaces = new DecimalFormat("0.00");
	Paint paint;
	Paint paintInstruction;

	public void init() {
		step = 20;
		framesCouner = 0;
		freq = Core.getTickFrequency();
		prevFrameTime = Core.getTickCount();
		strfps = "";

		paint = new Paint();
		paint.setColor(Color.BLUE);
		paint.setTextSize(20);

		paintInstruction = new Paint();
		paintInstruction.setColor(Color.RED);
		paintInstruction.setTextSize(30);
	}

	public void measure() {
		framesCouner++;
		if (framesCouner % step == 0) {
			long time = Core.getTickCount();
			double fps = step * freq / (time - prevFrameTime);
			prevFrameTime = time;
			DecimalFormat twoPlaces = new DecimalFormat("0.00");
			strfps = twoPlaces.format(fps) + " FPS";
			Log.i(TAG, strfps);
		}
	}

	public void draw(Canvas canvas, float offsetx, float offsety) {
		canvas.drawText(strfps, 10 + offsetx, 60 + offsety, paint);
		canvas.drawText("Direction: " + BallFollowingBrain.sBallDirection,
				10 + offsetx, 60 + 30 + offsety, paint);
//		canvas.drawText(
//				"Throttle: "
//						+ twoPlaces.format(BallFollowingBrain.sRobotThrottle)
//						, 10 + offsetx, 60 + 60 + offsety, paint);
		canvas.drawText(
				"Distance: "
						+ twoPlaces.format(BallFollowingBrain.sBallDistance)+ "m",
				10 + offsetx, 60 + 90 + offsety, paint);
		canvas.drawText(BallFollowingBrain.sRobotInstruction,
				canvas.getWidth() / 2 - 60, canvas.getHeight() - 20,
				paintInstruction);
	}

}
